#ifndef OGSE_RAIN_DROPS_H
#define OGSE_RAIN_DROPS_H
uniform sampler2D s_rain_drops;
uniform sampler2D s_rain_drops_streaks;
uniform sampler2D s_rain_drops_scroll;
uniform float4 rain_params;
#define DROP_SCROLL_SPEED half(0.5)	//   
half3 calc_rain_drops (float2 tc, float3 img) {
        half4 t_drop = tex2D(s_rain_drops, tc);
        half4 t_streaks = tex2D(s_rain_drops_streaks, tc);
        half t_scroll = tex2D(s_rain_drops_scroll, tc - float2(0.h, 0.1h) * timers.x * DROP_SCROLL_SPEED).x;
        half3 drop_color = normalize(img) / 18;
        
        float time = (rain_params.x - rain_params.y)/rain_params.z + lerp(0, saturate(rain_params.y/rain_params.z), saturate(rain_params.y));
        time *= 8;
        float static_image_lerp = ((t_drop.x - 0.5)*saturate(time) 
                                                        + (t_drop.y - 0.5)*saturate(time - 1) 
                                                        + (t_drop.z - 0.5)*saturate(time - 2) 
                                                        + (t_drop.w - 0.5)*saturate(time - 3)) * 2.h;
        half3 static_image = lerp(img, drop_color, static_image_lerp);
        
        float scroll_image_lerp =((t_streaks.x - 0.5)*saturate(time - 4) 
                                                        + (t_streaks.y - 0.5)*saturate(time - 5) 
                                                        + (t_streaks.z - 0.5)*saturate(time - 6) 
                                                        + (t_streaks.w - 0.5)*saturate(time - 7)) * 2.h * t_scroll;
        half3 scroll_image = lerp(img, drop_color, scroll_image_lerp);
        return ((static_image + scroll_image) / 2 - img) * script_params.y;
}
#endif